// Lexicon Web Script

var isIE = false;
var req;
var docUrl = 'data/words.xml';
var languages;
var languageTypes;
var fonts;
var fontSizes;
var allWords;
var rawWords;
var words;
var info;

function loadXMLDoc(url,changer) {
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = changer;
        req.open("GET", url, true);
        req.send(null);
    } else if (window.ActiveXObject) {
        isIE = true;
        req = new ActiveXObject("Microsoft.XMLHTTP");
        if (req) {
            req.onreadystatechange = changer;
            req.open("GET", url, true);
            req.send();
        }
    }
}

function generateItems() {
	info = req.responseXML.getElementsByTagName("info");
	setStyleByTag("body","font-family",rawGetElementTextNS("defaultFontName", info[0], 0),1);
	setStyleByTag("body","font-size",rawGetElementTextNS("defaultFontSize", info[0], 0) + "pt",1);
    var items = req.responseXML.getElementsByTagName("word");
    var inLangs = info[0].getElementsByTagName("language");
    languages = new Array(inLangs.length);
    languageTypes = new Array(inLangs.length);
    fonts = new Array(inLangs.length);
    fontSizes = new Array(inLangs.length);
    for (var i = 0; i < inLangs.length; i++) {
  		languages[i] = getElementTextNS("name", inLangs[i], 0);
  		languageTypes[languages[i]] = getElementTextNS("type", inLangs[i], 0);
  		fonts[i] = getElementTextNS("fontName", inLangs[i], 0);
  		fontSizes[i] = getElementTextNS("fontSize", inLangs[i], 0);
	}
	var lang;
	var color;
    var entries;
	allWords = new Array();
	rawWords = new Array();
	for (var i = 0; i < items.length; i++) {
		entries = items[i].getElementsByTagName("entry");
		allWords[i] = new Array();
		rawWords[i] = new Array();
		color = rawGetElementTextNS("color", items[i], 0);
		if (color != null)
			allWords[i]["_color"] = color;
		allWords[i]["_num"] = i + 1;
		for (var j = 0; j < entries.length; j++) {
			lang = entries[j].getAttribute("lang");
			allWords[i][lang] = getElementTextNS(languageTypes[lang], entries[j], 0);
			rawWords[i][lang] = rawGetElementTextNS(languageTypes[lang], entries[j], 0);
		}
	}
}

function createCookie(name,value) {
	var date = new Date();
	date.setTime(date.getTime()+(365*24*60*60*1000));
	document.cookie = name+"="+value+"; expires="+date.toGMTString()+"; path="+window.location.pathname;
}

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0) == ' ')
			c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0)
			return c.substring(nameEQ.length,c.length);
	}
	return null;
}

function textForLang(item, lang) {
	return words[item][languages[lang]];
}

function rawGetElementTextNS(local, parentElem, index) {
    var result = parentElem.getElementsByTagName(local)[index];
    if (result) {
        if (result.childNodes.length > 1) {
            return result.childNodes[1].nodeValue;
        } else {
            return result.firstChild.nodeValue;    		
        }
    } else {
        return null;
    }
}

function getElementTextNS(local, parentElem, index) {
	var result = rawGetElementTextNS(local, parentElem, index);
    if (result)
    	return result;
    else
        return "(undefined)";
}
